const schema = {"$schema":"https://json-schema.org/draft/2020-12/schema","$id":"AutorestOpenAPISchema.json","type":"object","properties":{"swagger":{"type":"string","const":"2.0"},"info":{"$ref":"#/$defs/Info"},"basePath":{"type":"string"},"schemes":{"type":"array","items":{"anyOf":[{"type":"string","const":"http"},{"type":"string","const":"https"},{"type":"string","const":"ws"},{"type":"string","const":"wss"}]}},"host":{"type":"string"},"x-ms-parameterized-host":{"$ref":"#/$defs/XmsParameterizedHost"},"produces":{"type":"array","items":{"type":"string"}},"consumes":{"type":"array","items":{"type":"string"}},"security":{"type":"array","items":{"$ref":"#/$defs/SecurityRequirement"}},"securityDefinitions":{"$ref":"#/$defs/SecurityDefinitions"},"tags":{"type":"array","items":{"$ref":"#/$defs/Tag"}},"paths":{"$ref":"#/$defs/Paths"},"x-ms-paths":{"$ref":"#/$defs/Paths"},"definitions":{"$ref":"#/$defs/RecordSchema"},"parameters":{"$ref":"#/$defs/RecordParameter"},"responses":{"$ref":"#/$defs/RecordResponse"},"externalDocs":{"$ref":"#/$defs/ExternalDocs"},"x-ms-permissions":{"$ref":"#/$defs/XmsPermissions"}},"required":["swagger","info","paths"],"$defs":{"Info":{"type":"object","properties":{"title":{"type":"string"},"version":{"type":"string"},"description":{"type":"string"},"termsOfService":{"type":"string"},"contact":{"$ref":"#/$defs/Contact"},"license":{"$ref":"#/$defs/License"}},"required":["title","version"]},"XmsParameterizedHost":{"type":"object","properties":{"hostTemplate":{"type":"string"},"useSchemePrefix":{"type":"boolean"},"positionInOperation":{"anyOf":[{"type":"string","const":"first"},{"type":"string","const":"last"}]},"parameters":{"type":"array","items":{"$ref":"#/$defs/Parameter"}}}},"SecurityRequirement":{"type":"object","properties":{},"unevaluatedProperties":{"type":"array","items":{"type":"string"}}},"SecurityDefinitions":{"type":"object","properties":{},"unevaluatedProperties":{"$ref":"#/$defs/SecurityScheme"}},"Tag":{"type":"object","properties":{"name":{"type":"string"},"description":{"type":"string"},"externalDocs":{"$ref":"#/$defs/ExternalDocs"}},"required":["name"]},"Paths":{"type":"object","properties":{},"unevaluatedProperties":{"$ref":"#/$defs/PathItem"},"x-ordering":"url"},"RecordSchema":{"type":"object","properties":{},"unevaluatedProperties":{"$ref":"#/$defs/Schema"}},"RecordParameter":{"type":"object","properties":{},"unevaluatedProperties":{"$ref":"#/$defs/Parameter"}},"RecordResponse":{"type":"object","properties":{},"unevaluatedProperties":{"$ref":"#/$defs/Response"}},"ExternalDocs":{"type":"object","properties":{"description":{"type":"string"},"url":{"type":"string"}},"required":["url"]},"XmsPermissions":{"type":"object","properties":{"actions":{"type":"string"},"dataActions":{"type":"string"},"rolesWithThesePermissions":{"type":"string"},"moreInfoLink":{"type":"string"}}},"Contact":{"type":"object","properties":{"name":{"type":"string"},"url":{"type":"string"},"email":{"type":"string"}}},"License":{"type":"object","properties":{"name":{"type":"string"},"url":{"type":"string"}},"required":["name"]},"Parameter":{"type":"object","properties":{"name":{"type":"string"},"in":{"anyOf":[{"type":"string","const":"body"},{"type":"string","const":"header"},{"type":"string","const":"query"},{"type":"string","const":"cookie"}]},"description":{"type":"string"},"required":{"type":"boolean"},"schema":{"$ref":"#/$defs/Schema"},"type":{"type":"string"},"format":{"type":"string"},"items":{"$ref":"#/$defs/Schema"},"collectionFormat":{"type":"string"},"default":{},"minimum":{"type":"number"},"exclusiveMinimum":{"type":"boolean"},"maximum":{"type":"number"},"exclusiveMaximum":{"type":"boolean"},"minLength":{"$ref":"#/$defs/nonNegativeInteger"},"maxLength":{"$ref":"#/$defs/nonNegativeInteger"},"pattern":{"type":"string"},"minItems":{"$ref":"#/$defs/nonNegativeInteger"},"maxItems":{"$ref":"#/$defs/nonNegativeInteger"},"uniqueItems":{"type":"boolean"},"minProperties":{"$ref":"#/$defs/nonNegativeInteger"},"maxProperties":{"$ref":"#/$defs/nonNegativeInteger"},"multipleOf":{"type":"number"},"enum":{"type":"array","items":{"type":"string"}},"x-ms-enum":{"$ref":"#/$defs/XmsEnum"},"x-ms-parameter-grouping":{"$ref":"#/$defs/XmsParameterGrouping"},"x-ms-parameter-location":{"anyOf":[{"type":"string","const":"client"},{"type":"string","const":"method"}]},"x-ms-api-version":{"type":"boolean"},"x-ms-client-default":{},"x-ms-header-collection-prefix":{"type":"string"},"x-ms-client-name":{"type":"string"},"x-ms-client-flatten":{"type":"boolean"}},"required":["name","in","collectionFormat"]},"SecurityScheme":{"type":"object","properties":{"type":{"type":"string"},"description":{"type":"string"},"name":{"type":"string"},"in":{"type":"string"},"flow":{"type":"string"},"authorizationUrl":{"type":"string","format":"uri"},"scopes":{"$ref":"#/$defs/RecordString"}},"required":["type"]},"PathItem":{"type":"object","properties":{"$ref":{"type":"string"},"parameters":{"type":"array","items":{"$ref":"#/$defs/Parameter"}},"get":{"$ref":"#/$defs/Operation"},"put":{"$ref":"#/$defs/Operation"},"post":{"$ref":"#/$defs/Operation"},"patch":{"$ref":"#/$defs/Operation"},"delete":{"$ref":"#/$defs/Operation"},"options":{"$ref":"#/$defs/Operation"},"head":{"$ref":"#/$defs/Operation"}}},"Schema":{"type":"object","properties":{"$ref":{"type":"string","description":"Ref to another schema"},"type":{"type":"string","description":"Schema type"},"format":{"type":"string"},"title":{"type":"string"},"description":{"type":"string"},"default":{},"minimum":{"type":"number"},"exclusiveMinimum":{"type":"boolean"},"maximum":{"type":"number"},"exclusiveMaximum":{"type":"boolean"},"minLength":{"$ref":"#/$defs/nonNegativeInteger"},"maxLength":{"$ref":"#/$defs/nonNegativeInteger"},"pattern":{"type":"string"},"minItems":{"$ref":"#/$defs/nonNegativeInteger"},"maxItems":{"$ref":"#/$defs/nonNegativeInteger"},"uniqueItems":{"type":"boolean"},"minProperties":{"$ref":"#/$defs/nonNegativeInteger"},"maxProperties":{"$ref":"#/$defs/nonNegativeInteger"},"multipleOf":{"type":"number"},"properties":{"$ref":"#/$defs/SchemaProperties"},"discriminator":{"type":"string"},"required":{"type":"array","items":{"type":"string"}},"enum":{"type":"array","items":{"type":"string"}},"x-ms-enum":{"$ref":"#/$defs/XmsEnum"},"x-nullable":{"type":"boolean"},"additionalProperties":{"anyOf":[{"$ref":"#/$defs/Schema"},{"type":"boolean"}]},"items":{"$ref":"#/$defs/Schema"},"allOf":{"type":"array","items":{"$ref":"#/$defs/Schema"}},"readOnly":{"type":"boolean"},"xml":{"$ref":"#/$defs/xml"},"externalDocs":{"$ref":"#/$defs/ExternalDocs"},"example":{},"x-ms-azure-resource":{"type":"boolean"},"x-ms-client-flatten":{"type":"boolean"},"x-ms-client-default":{},"x-ms-client-name":{"type":"string"},"x-ms-discriminator-value":{"type":"string"},"x-ms-external":{"type":"boolean"},"x-ms-identifiers":{"type":"array","items":{"type":"string"}},"x-ms-mutability":{"$ref":"#/$defs/XmsMutability"},"x-ms-secret":{"type":"boolean"}}},"Response":{"type":"object","properties":{"description":{"type":"string"},"schema":{"$ref":"#/$defs/Schema"},"headers":{"$ref":"#/$defs/Headers"},"x-ms-error-response":{"type":"boolean"},"examples":{"$ref":"#/$defs/Examples"}},"required":["description"]},"nonNegativeInteger":{"type":"integer","minimum":0},"XmsEnum":{"type":"object","properties":{"name":{"type":"string"},"modelAsString":{"type":"boolean"},"oldModelAsString":{"type":"boolean"},"modelAsExtensible":{"type":"boolean"},"values":{"type":"array","items":{"$ref":"#/$defs/XmsEnumValue"}}}},"XmsParameterGrouping":{"type":"object","properties":{"name":{"type":"string"},"postfix":{"type":"string"}}},"RecordString":{"type":"object","properties":{},"unevaluatedProperties":{"type":"string"}},"Operation":{"type":"object","properties":{"operationId":{"type":"string","description":"A unique identifier of the operation."},"tags":{"type":"array","items":{"type":"string"}},"summary":{"type":"string","description":"A brief summary of the operation."},"description":{"type":"string","description":"A longer description of the operation, GitHub Flavored Markdown is allowed."},"externalDocs":{"$ref":"#/$defs/ExternalDocs"},"produces":{"type":"array","items":{"type":"string"},"description":"A list of MIME types the API can produce."},"consumes":{"type":"array","items":{"type":"string"},"description":"A list of MIME types the API can consume."},"parameters":{"type":"array","items":{"$ref":"#/$defs/Parameter"}},"responses":{"$ref":"#/$defs/RecordResponse"},"schemes":{"type":"array","items":{"anyOf":[{"type":"string","const":"http"},{"type":"string","const":"https"},{"type":"string","const":"ws"},{"type":"string","const":"wss"}]}},"deprecated":{"type":"boolean"},"security":{"type":"array","items":{"$ref":"#/$defs/SecurityRequirement"}},"x-ms-client-name":{"type":"string"},"x-ms-examples":{"$ref":"#/$defs/XmsExamples"},"x-ms-long-running-operation-options":{"$ref":"#/$defs/XmsLongRunningOperationOptions"},"x-ms-long-running-operation":{"type":"boolean"},"x-ms-odata":{"type":"string"},"x-ms-pageable":{"$ref":"#/$defs/XmsPageable"},"x-ms-request-id":{"type":"string"}},"required":["responses"]},"SchemaProperties":{"type":"object","properties":{},"unevaluatedProperties":{"$ref":"#/$defs/Schema"},"x-ordering":"keep"},"xml":{"type":"object","properties":{"name":{"type":"string"},"namespace":{"type":"string"},"prefix":{"type":"string"},"attribute":{"type":"boolean"},"wrapped":{"type":"boolean"}}},"XmsMutability":{"type":"array","items":{"anyOf":[{"type":"string","const":"create"},{"type":"string","const":"read"},{"type":"string","const":"update"}]}},"Headers":{"type":"object","properties":{},"unevaluatedProperties":{"$ref":"#/$defs/Header"}},"Examples":{"type":"object","properties":{},"unevaluatedProperties":{"type":"object","properties":{}}},"XmsEnumValue":{"type":"object","properties":{"name":{"type":"string"},"value":{},"description":{"type":"string"},"allowedValues":{"type":"array","items":{}}},"required":["value"]},"XmsExamples":{"type":"object","properties":{},"unevaluatedProperties":{"type":"object","properties":{}},"description":"Describes the 'x-ms-examples' extension."},"XmsLongRunningOperationOptions":{"type":"object","properties":{"final-state-via":{"anyOf":[{"type":"string","const":"azure-async-operation"},{"type":"string","const":"location"},{"type":"string","const":"original-uri"},{"type":"string","const":"operation-location"},{"type":"string","const":"final-state-schema"}],"description":"How to determine the final state of the operation. Possible Values:\n- `azure-async-operation` - poll until terminal state, the final response will be available at the uri pointed to by the header `Azure-AsyncOperation`\n- `location`  - poll until terminal state, the final response will be available at the uri pointed to by the header `Location`\n- `operation-location` - poll until terminal state, the final response will be available at the uri pointed to by the header `Operation-Location`"},"final-state-schema":{"type":"string"}},"required":["final-state-via"],"description":"Indicates whether the operation is long running (asynchronous). `true` value indicates that it is a long running operation."},"XmsPageable":{"type":"object","properties":{"nextLinkName":{"anyOf":[{"type":"string"},{"type":"null"}]},"itemName":{"anyOf":[{"type":"string"},{"type":"null"}]},"operationName":{"anyOf":[{"type":"string"},{"type":"null"}]}}},"Header":{"type":"object","properties":{"type":{"anyOf":[{"type":"string","const":"string"},{"type":"string","const":"number"},{"type":"string","const":"integer"},{"type":"string","const":"boolean"},{"type":"string","const":"array"}]},"format":{"type":"string"},"description":{"type":"string"},"items":{"$ref":"#/$defs/Schema"},"collectionFormat":{"anyOf":[{"type":"string","const":"csv"},{"type":"string","const":"ssv"},{"type":"string","const":"tsv"},{"type":"string","const":"pipes"}]},"default":{},"minimum":{"type":"number"},"exclusiveMinimum":{"type":"boolean"},"maximum":{"type":"number"},"exclusiveMaximum":{"type":"boolean"},"minLength":{"$ref":"#/$defs/nonNegativeInteger"},"maxLength":{"$ref":"#/$defs/nonNegativeInteger"},"pattern":{"type":"string"},"minItems":{"$ref":"#/$defs/nonNegativeInteger"},"maxItems":{"$ref":"#/$defs/nonNegativeInteger"},"uniqueItems":{"type":"boolean"},"minProperties":{"$ref":"#/$defs/nonNegativeInteger"},"maxProperties":{"$ref":"#/$defs/nonNegativeInteger"},"multipleOf":{"type":"number"},"enum":{"type":"array","items":{"type":"string"}},"x-ms-client-name":{"type":"string"},"x-ms-enum":{"$ref":"#/$defs/XmsEnum"},"x-ms-header-collection-prefix":{"type":"string"},"x-ms-secret":{"type":"boolean"},"x-nullable":{"type":"boolean"}},"required":["type"]}}};

export { schema as default };
